treeGame.titleMenu = function(game){
	
    this.game = game;		//	a reference to the currently running game
    this.add;		//	used to add sprites, text, groups, etc
    this.camera;	//	a reference to the game camera
    this.cache;		//	the game cache
    this.input;		//	the global input manager (you can access this.input.keyboard, this.input.mouse, as well from it)
    this.load;		//	for preloading assets
    this.math;		//	lots of useful common math operations
    this.sound;		//	the sound manager - add a sound, play one, set-up markers, etc
    this.stage;		//	the game stage
    this.time;		//	the clock
    this.tweens;	//	the tween manager
    this.world;		//	the game world
    this.particles;	//	the particle manager
    this.physics;	//	the physics manager
    this.rnd;		//	the repeatable random number generator
   

	titleMenu = this;
	
	treeGame.difficulty = 2;
	
	treeGame.bmd = null;
	
	treeGame.background = null;
	treeGame.overlayTexture = null;
	
	this.game.musicTriggered = false;
	
}

treeGame.titleMenu.prototype = {
	
	preload: function(){
		
			// Object Arrays
			treeGame.mountains = [];
			treeGame.menuClouds = [];
		
		
			// Define menuCloud
			treeGame.menuCloud = function (index, x, y) 
			{			
		        this.index = index;
		        
		        this.randomSprite = titleMenu.rnd.integerInRange(0, 3);
				if (this.randomSprite == 0)
				{
					this.menuCloudSprite = titleMenu.add.sprite(x, y, 'textureAtlas', 'cloud1');
				} else if (this.randomSprite == 1) {
					this.menuCloudSprite = titleMenu.add.sprite(x, y, 'textureAtlas', 'cloud2');
				} else if (this.randomSprite == 2) {
					this.menuCloudSprite = titleMenu.add.sprite(x, y, 'textureAtlas', 'cloud3');
				} else if (this.randomSprite == 3) {
					this.menuCloudSprite = titleMenu.add.sprite(x, y, 'textureAtlas', 'cloud4');
				} else {
					this.menuCloudSprite = titleMenu.add.sprite(x, y, 'textureAtlas', 'cloud1');
				}
				
				this.menuCloudSprite.alpha = .5;
		
		        titleMenu.physics.enable(this.menuCloudSprite, Phaser.Physics.ARCADE);
				this.menuCloudSprite.body.enable = true;
				this.menuCloudSprite.body.collideWorldBounds = false;
		        this.menuCloudSprite.body.drag.x = 500;
		        this.menuCloudSprite.body.drag.y = 500;
		        this.menuCloudSprite.anchor.setTo(0.5, 0.5);
		        
		        this.randomSpeedVariation = titleMenu.rnd.integerInRange(-50, 50);
		       
		        // Add the menuCloud to the menuCloud group
		        menuCloudGroup.add(this.menuCloudSprite);
		        
		        // Make it rain
				this.rainEmitter = titleMenu.add.emitter(0, 0, 50);
				this.rainEmitter.width = this.menuCloudSprite.width;
				this.rainEmitter.angle = 0;
				this.rainEmitter.alpha = 0.25; 
				this.rainEmitter.makeParticles('textureAtlas', 'rain');
				this.rainEmitter.minParticleScale = 0.1;
				this.rainEmitter.maxParticleScale = 1;
				this.rainEmitter.setYSpeed(300, 500);
				this.rainEmitter.setXSpeed(-5, 5);
				this.rainEmitter.minRotation = 0;
				this.rainEmitter.maxRotation = 0;
				this.rainEmitter.start(false, 2000, 150, 0);
				backgroundEmitterGroup.add(this.rainEmitter);
				this.rainEmitter.alignIn(this.menuCloudSprite, Phaser.CENTER);
				
			}
			
			// Define Mountain
			treeGame.mountain = function (index, x, y, width, height, alpha, key) 
			{			
			    this.mountainSprite = titleMenu.add.tileSprite(x, y, width, height, key);
		        this.mountainSprite.alpha = alpha;
		        
		        if (window.innerWidth < window.innerHeight)
		        {
			        this.mountainSprite.scale.y = 1.25;
		        } else
		        {

		        }
		        		        
		        this.mountainSprite.fixedToCamera = true;
		        
		        // Add the sky to the sky group
		        mountainGroup.add(this.mountainSprite);		               	
			}

	},

  	create: function(){
	  	
	  	// Viewport Scaling
		this.game.scale.startFullScreen(false);
		this.game.scale.scaleMode = Phaser.ScaleManager.RESIZE;
		this.game.scale.pageAlignHorizontally = true;
		this.game.scale.pageAlignVertically = true;
		this.game.scale.refresh();
		
		// Fullscreen Hotkey
		var fullscreenKey = this.game.input.keyboard.addKey(Phaser.Keyboard.F);	
	    fullscreenKey.onDown.add(this.goFull, this);
	    
	    // Start Music
	    if (this.game.musicTriggered == false)
	    {
		    var randomMusic = titleMenu.rnd.integerInRange(0, 2);
		    switch(randomMusic)
		    {
			    case 0:
			        var music = this.game.add.audio('vastMagicMusic', .1, false);
			        break;
			    case 1: 
			        var music = this.game.add.audio('kalimbaCavernMusic', .1, false);
			        break;
			    case 2: 
			        var music = this.game.add.audio('kalimbaCavernMusic2', .1, false);
			        break;
		    }
		    
			music.play();
			
			music.onStop.add(function(){
				
				var randomMusic = titleMenu.rnd.integerInRange(0, 2);
			    switch(randomMusic)
			    {
				    case 0:
				        var music = this.game.add.audio('vastMagicMusic', .1, false);
				        break;
				    case 1: 
				        var music = this.game.add.audio('kalimbaCavernMusic', .1, false);
				        break;
				    case 2: 
				        var music = this.game.add.audio('kalimbaCavernMusic2', .1, false);
				        break;
			    }
			    music.play();
				
			}, this);
			
			this.game.musicTriggered = true;
	    }

	    // Create Groups (Background to Foreground)
	    backgroundGradientGroup = titleMenu.add.group();
	    menuCloudGroup = titleMenu.add.group();
	    mountainGroup = titleMenu.add.group();
	    backgroundEmitterGroup = titleMenu.add.group();
	    titleLogoGroup = titleMenu.add.group();

	    
	    
		// Background
	  	treeGame.bmd = titleMenu.make.bitmapData(window.innerWidth, window.innerHeight);
	  	treeGame.bmd.addToWorld();
	  	
	    //  Create Background Circles
/*
	    outerCircle = new Phaser.Circle((window.innerWidth)/2, (window.innerHeight)*.25, window.innerWidth);
	    innerCircle = new Phaser.Circle((window.innerWidth)/2, (window.innerHeight)*.25, 300);


	  	
		var backgroundGradient = treeGame.bmd.context.createRadialGradient(innerCircle.x, innerCircle.y, innerCircle.radius, outerCircle.x, outerCircle.y, outerCircle.radius);
		backgroundGradient.addColorStop(0, '#cfded6');
		backgroundGradient.addColorStop(1, '#C0D9DD');
		
	    treeGame.bmd.cls();
	    treeGame.bmd.circle(outerCircle.x, outerCircle.y, outerCircle.radius, backgroundGradient);
*/

        if (window.innerWidth < window.innerHeight)
        {
	        var titleX = ((window.innerWidth)/2);
            var titleY = ((window.innerHeight) * .25);
        } else
        {
	        var titleX = ((window.innerWidth) * .25);
            var titleY = ((window.innerHeight) * .5);
        }

        
	  	
	    this.glowSprite = this.add.sprite(titleX, titleY, 'glowImage');
	  	this.glowSprite.scale.x = .5;
	  	this.glowSprite.scale.y = .5;
	    this.glowSprite.anchor.setTo(0.5,0.5);
	    this.glowSprite.alpha = 0;
	    titleLogoGroup.add(this.glowSprite);

	  	this.titleLogo = this.add.sprite(titleX, titleY, 'titleImage');
	  	this.titleLogo.scale.x = .35;
	  	this.titleLogo.scale.y = .35;
	    this.titleLogo.anchor.setTo(0.5,0.5);
	    this.titleLogo.alpha = 0;
	    titleLogoGroup.add(this.titleLogo);
	    

			
		// Menu Background Emitter
		this.leafAndSeedEmitter = titleMenu.add.emitter(0, 0, 25);
		this.leafAndSeedEmitter.width = window.innerWidth*2;
		this.leafAndSeedEmitter.angle = 0;
		this.leafAndSeedEmitter.alpha = .25; 
		this.leafAndSeedEmitter.makeParticles('textureAtlas', ['leafOak', 'seedPine', 'seedOak', 'seedBirch', 'seedBeech', 'leafBeech', 'pineNeedles', 'leafBirch']);
/*
		this.leafAndSeedEmitter.minParticleScale = 0.5;
		this.leafAndSeedEmitter.maxParticleScale = 1;
*/
		this.leafAndSeedEmitter.setYSpeed(2, 5);
		this.leafAndSeedEmitter.setXSpeed(-15, 15);
		this.leafAndSeedEmitter.minRotation = -250;
		this.leafAndSeedEmitter.maxRotation = 250;
		this.leafAndSeedEmitter.start(false, 5000, 400, 0);
		backgroundEmitterGroup.add(this.leafAndSeedEmitter);
	    
		// Create menuClouds
		
        for (var i = 0; i < 3; i++)
	    {
		    var yRandomVariation = titleMenu.rnd.integerInRange(-200, 200);
            treeGame.menuClouds.push( new treeGame.menuCloud(treeGame.menuClouds.length, this.world.randomX, 300 + yRandomVariation, 1));
	    }		    
	    this.leavesSprite = this.add.sprite((window.innerWidth)/2, (window.innerHeight)/2, 'loadingBarImage');
		this.leavesSprite.anchor.setTo(0.5,0.5);
		
		this.leavesFadeIn = this.add.tween(this.leavesSprite).to( { alpha: 1 }, 1000, Phaser.Easing.Quadratic.InOut, true);
		this.leavesMoveUp = this.add.tween(this.leavesSprite).to( { x: titleX , y: titleY }, 1000, Phaser.Easing.Quadratic.InOut, true);
		this.leavesMoveUp.onComplete.add(function () { 
			this.leavesFadeOut = this.add.tween(this.leavesSprite).to( { alpha: 0 }, 0, Phaser.Easing.Quadratic.InOut, true);
			this.glowSpriteFadesIn = this.add.tween(this.glowSprite).to( { alpha: .75 }, 2500, Phaser.Easing.Quadratic.InOut, true, 0, -1, true);
		    this.titleLogoFadesIn = this.add.tween(this.titleLogo).to( { alpha: 1 }, 1000, Phaser.Easing.Quadratic.InOut, true);
		    this.titleLogoMovesUpAndDown = this.add.tween(this.titleLogo).to({y:'+5'}, 0, Phaser.Easing.Quadratic.InOut, true, 750, -1, true);
		    this.titleLogoMovesLeftAndRight = this.add.tween(this.titleLogo).to({x:'-5'}, 0, Phaser.Easing.Quadratic.InOut, true, 500, -1, true);
		    this.titleLogoRotates = this.add.tween(this.titleLogo).to({angle:'+1'}, 0, Phaser.Easing.Quadratic.InOut, true, 750, -1, true);

			}, this);
	    
	    // Create Mountains
        treeGame.mountains.push( new treeGame.mountain(treeGame.mountains.length, 0, 0, this.game.world.width, this.game.world.height, .25, 'mountainImage'));

	    
	    this.createText();
	        
		var texture = titleMenu.add.tileSprite(0,0,4000,4000,'textureImage');
        texture.blendMode = Phaser.blendModes.COLOR_BURN;
        texture.alpha = .35;

		overlayTexture = titleMenu.add.group();
		overlayTexture.add(texture);
	    
	},
	
	update: function(){
		
		// menuCloud Movement
		
		for (var i = 0; i < treeGame.menuClouds.length; i++)
		{ 
            treeGame.menuClouds.forEach(function (menuCloud) {
	            titleMenu.world.wrap(menuCloud.menuCloudSprite, 100, false);
                titleMenu.physics.arcade.velocityFromAngle(0, 100 + menuCloud.randomSpeedVariation, menuCloud.menuCloudSprite.body.velocity);
                menuCloud.rainEmitter.x = menuCloud.menuCloudSprite.body.x + menuCloud.menuCloudSprite.width/2;
            });
        }
	},
	
	createText: function(){
		
		if (window.innerWidth < window.innerHeight)
        {
	        var titleX = ((window.innerWidth)/2);
            var titleY = ((window.innerHeight) * .75);
        } else
        {
	        var titleX = ((window.innerWidth) * .75);
            var titleY = ((window.innerHeight) * .5);
        }
		
		this.startGameText = this.add.text(titleX, titleY - 50, "Start Game", this.fontStyle);
		this.startGameText.align = 'center';
	    this.startGameText.fill = '#5b5760';
	    this.startGameText.anchor.setTo(0.5);
	    this.startGameText.font = 'Palatino';
	    this.startGameText.fontSize = 40;
	    this.startGameText.alpha = 0;
	    this.add.tween(this.startGameText).to( { alpha: 1 }, 1500, Phaser.Easing.Quadratic.InOut, true);
	    this.startGameText.padding.set(10, 16);
	    this.startGameText.inputEnabled = true;
	    this.startGameText.events.onInputOver.add(this.startGameTextOver, this);
	    this.startGameText.events.onInputOut.add(this.startGameTextOut, this);
	    this.startGameText.events.onInputUp.add(this.startGameTextUp, this);
	    
	    this.settingsText = this.add.text(titleX, titleY + 50, "Settings", this.fontStyle);
		this.settingsText.align = 'center';
	    this.settingsText.fill = '#5b5760';
	    this.settingsText.anchor.setTo(0.5);
	    this.settingsText.font = 'Palatino';
	    this.settingsText.fontSize = 40;
	    this.settingsText.alpha = 0;
	    this.add.tween(this.settingsText).to( { alpha: 1 }, 1500, Phaser.Easing.Quadratic.InOut, true);
	    this.settingsText.padding.set(10, 16);
	    this.settingsText.inputEnabled = true;
	    this.settingsText.events.onInputOver.add(this.settingsTextOver, this);
	    this.settingsText.events.onInputOut.add(this.settingsTextOut, this);
	    this.settingsText.events.onInputUp.add(this.settingsTextUp, this);

		this.createdByText = this.add.text(((window.innerWidth)/2), window.innerHeight - ((window.innerHeight) * .15), "Created by Corey Van Hoosen.", this.fontStyle);
		this.createdByText.align = 'center';
	    this.createdByText.fill = '#5b5760';
	    this.createdByText.anchor.setTo(0.5);
	    this.createdByText.font = 'Palatino';
	    this.createdByText.fontSize = 20;
	    this.createdByText.alpha = 0;
	    this.add.tween(this.createdByText).to( { alpha: 1 }, 2000, Phaser.Easing.Quadratic.InOut, true);
	    this.createdByText.inputEnabled = true;
	    this.createdByText.inputEnabled = true;
	    this.createdByText.events.onInputOver.add(this.createdByTextOver, this);
	    this.createdByText.events.onInputOut.add(this.createdByTextOut, this);
	    this.createdByText.events.onInputUp.add(this.createdByTextUp, this);
	    
		
	},
	
	startGameTextOut: function() {
	
	    this.startGameText.fill = '#5b5760';
	    this.add.tween(this.titleLeafLeftSprite).to( { alpha: 0 }, 200, Phaser.Easing.Quadratic.InOut, true);	    
	    this.add.tween(this.titleLeafRightSprite).to( { alpha: 0 }, 200, Phaser.Easing.Quadratic.InOut, true);
	
	},
	
	startGameTextOver: function() {
	
	    this.startGameText.fill = '#8f9250';
	    this.titleLeafLeftSprite = titleMenu.add.sprite(-150, -15, 'textureAtlas', 'leafOak');
			
	    this.titleLeafRightSprite = titleMenu.add.sprite(135, -15, 'textureAtlas', 'leafBeech');
	    
	    this.titleLeafRightSprite.angle = 180;
	    
	    this.titleLeafRightSprite.scale.y = -1;
	    
	    this.titleLeafLeftSprite.alpha = 0;
	    this.titleLeafRightSprite.alpha = 0;
	    
		this.titleLeafLeftSprite.anchor.setTo(0.5);
		this.titleLeafRightSprite.anchor.setTo(0.5);	    
	    
	    this.add.tween(this.titleLeafLeftSprite).to( { alpha: 1 }, 200, Phaser.Easing.Quadratic.InOut, true);	    
	    this.add.tween(this.titleLeafRightSprite).to( { alpha: 1 }, 200, Phaser.Easing.Quadratic.InOut, true);
	    
	    this.startGameText.addChild(this.titleLeafLeftSprite);
	    this.startGameText.addChild(this.titleLeafRightSprite);
	
	},
		
	startGameTextUp: function() {
	
	    this.game.state.start("SelectLevel");
	
	},
	
	
		settingsTextOut: function() {
	
	    this.settingsText.fill = '#5b5760';
	    this.add.tween(this.titleLeafLeftSprite).to( { alpha: 0 }, 200, Phaser.Easing.Quadratic.InOut, true);	    
	    this.add.tween(this.titleLeafRightSprite).to( { alpha: 0 }, 200, Phaser.Easing.Quadratic.InOut, true);
	
	},
	
	settingsTextOver: function() {
	
	    this.settingsText.fill = '#8f9250';
	    this.titleLeafLeftSprite = titleMenu.add.sprite(-150, -15, 'textureAtlas', 'leafOak');
			
	    this.titleLeafRightSprite = titleMenu.add.sprite(135, -15, 'textureAtlas', 'leafBeech');
	    
	    this.titleLeafRightSprite.angle = 180;
	    
	    this.titleLeafRightSprite.scale.y = -1;
	    
	    this.titleLeafLeftSprite.alpha = 0;
	    this.titleLeafRightSprite.alpha = 0;
	    
		this.titleLeafLeftSprite.anchor.setTo(0.5);
		this.titleLeafRightSprite.anchor.setTo(0.5);	    
	    
	    this.add.tween(this.titleLeafLeftSprite).to( { alpha: 1 }, 200, Phaser.Easing.Quadratic.InOut, true);	    
	    this.add.tween(this.titleLeafRightSprite).to( { alpha: 1 }, 200, Phaser.Easing.Quadratic.InOut, true);
	    
	    this.settingsText.addChild(this.titleLeafLeftSprite);
	    this.settingsText.addChild(this.titleLeafRightSprite);
	
	},
	
	settingsTextUp: function() {
	
	    this.game.state.start("SettingsMenu");
	
	},

	createdByTextOut: function() {
	
	    this.createdByText.fill = '#5b5760';
	    this.add.tween(this.titleLeafLeftSprite).to( { alpha: 0 }, 200, Phaser.Easing.Quadratic.InOut, true);	    
	    this.add.tween(this.titleLeafRightSprite).to( { alpha: 0 }, 200, Phaser.Easing.Quadratic.InOut, true);
	
	},
	
	createdByTextOver: function() {
	
	    this.createdByText.fill = '#8f9250';
	    this.titleLeafLeftSprite = titleMenu.add.sprite(-200, -10, 'textureAtlas', 'leafOak');
			
	    this.titleLeafRightSprite = titleMenu.add.sprite(205, -10, 'textureAtlas', 'leafBeech');
	    
	    this.titleLeafRightSprite.angle = 180;
	    
	    this.titleLeafRightSprite.scale.y = -1;
	    
	    this.titleLeafLeftSprite.alpha = 0;
	    this.titleLeafRightSprite.alpha = 0;
	    
		this.titleLeafLeftSprite.anchor.setTo(0.5);
		this.titleLeafRightSprite.anchor.setTo(0.5);	    
	    
	    this.add.tween(this.titleLeafLeftSprite).to( { alpha: 1 }, 200, Phaser.Easing.Quadratic.InOut, true);	    
	    this.add.tween(this.titleLeafRightSprite).to( { alpha: 1 }, 200, Phaser.Easing.Quadratic.InOut, true);
	    
	    this.createdByText.addChild(this.titleLeafLeftSprite);
	    this.createdByText.addChild(this.titleLeafRightSprite);
	
	},
	
	createdByTextUp: function() {
	
	    var portfolioLink = window.open('http://www.coreyvanhoosen.com/', '_blank');
	    portfolioLink.focus();
	
	},	


	
	goFull: function() 
	{
	
	    if (titleMenu.game.scale.isFullScreen)
	    {
	        titleMenu.game.scale.stopFullScreen();
	    }
	    else
	    {
	        titleMenu.game.scale.startFullScreen(false);
	    }
	}
}